{ :Unit para implementar el formulario principal.
  @author Neftal -Germn Estvez-
}
unit FMain;

{ =========================================================================

  Formaulario principal de la aplicacin

  Unit

  ========================================================================
  Historia de las Versiones
  ------------------------------------------------------------------------

  21/04/2011     Neftal -Germn Estvez-
  http://neftali.clubdelphi.com
  * Creacin.
  ------------------------------------------------------------------------
  ...

  =========================================================================

  Errores detectados no corregidos

  ========================================================================= }

// =========================================================================
//
// I N T E R F A C E
//
// =========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, ExtCtrls, Menus, ComCtrls, ToolWin, ActnList,
  ImgList, StdCtrls;

type
  TFormMain = class(TForm)
    StatusBar1: TStatusBar;
    tbMain: TToolBar;
    ToolButton1: TToolButton;
    tbOpen: TToolButton;
    ToolButton3: TToolButton;
    MainMenu1: TMainMenu;
    oDialog: TOpenDialog;
    ilMain: TImageList;
    alMain: TActionList;
    ActionAbrirRuta: TAction;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    ActionIrWebIBPIndex: TAction;
    ActionIrWebAutor: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    pnlLink: TPanel;
    ToolButton4: TToolButton;
    ActionGuardarFichero: TAction;
    ActionImprimir: TAction;
    SDPDF: TSaveDialog;
    pnlCentral: TPanel;
    wbIBPIndex: TWebBrowser;
    pnlArrastrar: TPanel;
    imgPanelInfo: TImage;
    mmPanelInfo: TMemo;
    ActionCerrar: TAction;
    ToolButton8: TToolButton;
    procedure ActionAbrirRutaExecute(Sender: TObject);
    procedure wbIBPIndexDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure ActionIrWebIBPIndexExecute(Sender: TObject);
    procedure ActionIrWebAutorExecute(Sender: TObject);
    procedure ActionImprimirExecute(Sender: TObject);
    procedure ActionGuardarFicheroExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ActionCerrarExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    IBPIndexPDFFilename:String;
    IBPIndexPage:String;
    fName, tempName:string;
    // Originales para el arrastre
    originalImageWindowProc: TWndMethod;
    originalMemoWindowProc: TWndMethod;

    // Analizar un track
    procedure Analizar(TrackName:string);

    // Al arrastrar ficheros.
    procedure FilesDrop(var Msg: TWMDROPFILES);
    // Para el arrastre desde el expolorador
    procedure ImageWindowProc(var Msg: TMessage);
    procedure MemoWindowProc(var Msg: TMessage);

    // descargar un fichero;
    function DownloadFile(SourceFile, DestFile: string): boolean;
    // evento para capturar la finalizacin del thread
    procedure TerminateThread(Sender: TObject);

    // procedimientos para obtener path
    function AppPath(): string;
    function AppTempPath(): string;

  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

// =========================================================================
//
// I M P L E M E N T A T I O N
//
// =========================================================================
implementation

{$R *.dfm}

uses
  UrlMon, ShellAPI, UConstantes, UTWebThread, MSHTML, FAbout;


procedure TFormMain.ImageWindowProc(var Msg: TMessage);
begin
  // recibir ficheros
  if Msg.Msg = WM_DROPFILES then begin
    FilesDrop(TWMDROPFILES(Msg))
  end
  else begin
    originalImageWindowProc(Msg);
  end;
end;

procedure TFormMain.MemoWindowProc(var Msg: TMessage);
begin
  // recibir ficheros
  if Msg.Msg = WM_DROPFILES then begin
    FilesDrop(TWMDROPFILES(Msg))
  end
  else begin
    originalMemoWindowProc(Msg);
  end;
end;


// procedimientos para obtener path de la aplicacin
function TFormMain.AppPath: string;
begin
  Result := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
end;

// procedimientos para obtener path temporal
function TFormMain.AppTempPath: string;
begin
  Result := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
  Result := IncludeTrailingBackslash(Result + STR_TEMP_DIR);
  ForceDirectories(Result);
end;

procedure TFormMain.ActionAbrirRutaExecute(Sender: TObject);
var
  b:Boolean;
begin
  // Abrir
  b := oDialog.Execute;
  //
  if not(b) then begin
    Exit;
  end;

  // Cargar
  fName := oDialog.FileName;
  // No Existe?
  if not FileExists(fName) then begin
    MessageDlg(Format('No existe el fichero de track.'+#13+#10+'<%s>',[fName]), mtWarning, [mbOK], 0);
    Exit;
  end;

  // Analizar el track
  Analizar(fName);

end;

procedure TFormMain.TerminateThread(Sender: TObject);
var
  TS: TStrings;
  th: TWebThread;
begin


  // Acceder a los datos
  th := TWebThread(Sender);

  // Guardar la respuesta
  TS := TStringList.Create;
  try
    TS.Add(th.Response);
    tempName := AppTempPath() + '~res' + IntToStr(Random(1000)) + '.html';
    TS.SaveToFile(tempName);
    // Browser
    wbIBPIndex.Navigate(th.URLNavigate);
    IBPIndexPDFFilename := th.URLPDF;
    IBPIndexPage := th.URLNavigate;

    // problemas??
    if (th.URLPDF = STR_EMPTY) and (th.URLNavigate = STR_EMPTY) then begin
      MessageDlg('Se ha producido un error al analizar el track.'+#13+#10+'Es posible que no tenga acceso a internet o que el fichero de track sea incorrecto.', mtWarning, [mbOK], 0);
      StatusBar1.Panels[0].Text := STR_EMPTY;
      pnlArrastrar.Visible := True;
      Exit;
    end
    else begin
      // titulo
      StatusBar1.Panels[0].Text := ExtractFileName(fName);
    end;

  finally
    FreeAndNil(TS);
  end;

  th.Terminate;

end;

procedure TFormMain.wbIBPIndexDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var
  Doc: IHTMLDocument2; // current HTML document
begin

  // ocultar barras de desplazamiento
  Doc := wbIBPIndex.Document as IHTMLDocument2;

end;

procedure TFormMain.ActionIrWebIBPIndexExecute(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(IBPINDEX_INIPAGE), nil, nil, SW_SHOW);
end;

procedure TFormMain.ActionIrWebAutorExecute(Sender: TObject);
begin
  FormAbout := TFormAbout.CReate(Application);
  try
    FormAbout.ShowModal;
  finally
    FreeAndNil(FormAbout);
  end;
end;

procedure TFormMain.ActionImprimirExecute(Sender: TObject);
const
  OLECMDID_PRINT = $00000006;
  OLECMDEXECOPT_PROMPTUSER = $00000001;
begin
  wbIBPIndex.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER);
end;

procedure TFormMain.ActionGuardarFicheroExecute(Sender: TObject);
var
  Str: string;
begin

  // Hay fichero?
  if (IBPIndexPDFFilename = STR_EMPTY) then begin
    exit;
  end;
  // Nombre del fichero a guardar
  Str := ChangeFileExt(fName, STR_EXTENSION_PDF);
  // Pedir fichero
  SDPDF.FileName := Str;
  // Guardar
  if SDPDF.Execute() then begin
    DownloadFile(IBPIndexPDFFilename, SDPDF.FileName);
  end;
end;

function TFormMain.DownloadFile(SourceFile, DestFile: string): boolean;
begin
  try
    Result := UrlDownloadToFile(nil, PChar(SourceFile), PChar(DestFile),
      0, nil) = 0;
  except
    Result := False;
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin

  // Configurar que los componentes acepten DragDrop
  originalImageWindowProc := imgPanelInfo.WindowProc;
  imgPanelInfo.WindowProc := ImageWindowProc;
  // memo
  originalMemoWindowProc := mmPanelInfo.WindowProc;
  mmPanelInfo.WindowProc := MemoWindowProc;
  // Aceptar ficheros arrastrados
  // DragAcceptFiles(imgArrastra.Handle, True);
  DragAcceptFiles(mmPanelInfo.Handle, True);

end;

// recibe un fichero de ruta cuando se arrastra
procedure TFormMain.FilesDrop(var Msg: TWMDROPFILES);
var
  i: Integer;
  DroppedFilename: string;
  numFiles: longInt;
  buffer: array [0 .. MAX_PATH] of char;
begin
  // Nmero de ficheros arrastrados (por ahora aceptamos el primero)
  numFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
  // Recorrido por todos los arrastrados
  for i := 0 to 0 { (numFiles - 1) } do begin
    DragQueryFile(Msg.Drop, i, @buffer, sizeof(buffer));
    // Proteccion
    try
      DroppedFilename := buffer;
      // Aadir un nuevo documento (sin nombre - manual)
      Analizar(DroppedFilename);
    except
      on E: Exception do begin
        MessageDlg('Fichero de track incorrecto.', mtError, [mbOK], 0);
        // Nada
      end;
    end;
  end;

end;

// Analizar un track.
procedure TFormMain.Analizar(TrackName: string);
var
  th:TWebThread;
begin

  //ini
  StatusBar1.Panels[0].Text := 'Analizando...';
  pnlArrastrar.Visible := False;
  fName := TrackName;

  // Crear el Thread para navegar
  // Ini
  wbIBPIndex.Navigate(STR_BLANK_PAGE);

  th := TWebThread.Create(fName, wbIBPIndex);
  // th.FreeOnTerminate := False;
  th.OnTerminate := TerminateThread;
  th.Resume;

end;

procedure TFormMain.FormResize(Sender: TObject);
begin

  // Reajustar el panel de arrastre
  pnlArrastrar.Left := (Self.Width div 2) - (pnlArrastrar.Width DIV 2);
  pnlArrastrar.Top := (Self.Height div 2) - (pnlArrastrar.Height DIV 2);

end;

procedure TFormMain.ActionCerrarExecute(Sender: TObject);
begin
  Self.Close;
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
  if (MessageDlg('Realmente desea cerrar la aplicacin?',
        mtConfirmation, [mbYes, mbNo], 0) in [mrYes]) then begin

    // Borrar ficheros
    try
      DeleteFile (ApptempPath() + 'ibp.html');
      DeleteFile(tempName);
    finally
      // Nada
    end;

    CanClose := True;
  end;
end;

end.
