{ :Unit para implementar la clase TWebThread.
  @author Neftal -Germn Estvez-
}
unit UTWebThread;
{ =========================================================================

  Procedimientos genricos

  Unit

  ========================================================================
  Historia de las Versiones
  ------------------------------------------------------------------------

  25/01/2011     Neftal -Germn Estvez-
  http://neftali.clubdelphi.com
  * Creacin.
  ------------------------------------------------------------------------
  ...

  =========================================================================

  Errores detectados no corregidos

  ========================================================================= }

// =========================================================================
//
// I N T E R F A C E
//
// =========================================================================
interface

uses
  Classes, ExtCtrls, Windows, ComCtrls, SHDocVw,
  IdMultipartFormData,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

type

  { : Clase para realizar consultas utilizando thread a la Web. }
  TWebThread = class(TThread)
  private
    IdHTTP: TidHTTP;
    Stream: TIdMultipartFormDataStream;
    FTrackFileName: string;
    FwebBrowser: TWebBrowser;
    FResponse: string;
  private
    FURLNavigate: string;
    FURLPDF: string;
    function _RepairLinks(StrPage: string; var URLpage: string;
      var UrlPDF: string): string;
  protected

  public
    // ejecutar el procedimniento.
    procedure Execute; override;
    // componente de navegacin.
    property webBrowser: TWebBrowser read FwebBrowser write FwebBrowser;
    // Fichero de Track/ruta.
    property TrackFileName: string read FTrackFileName write FTrackFileName;
    // : Propiedad para recoger la respuesta desde la Web.
    property Response: string read FResponse write FResponse;
    // URL de navegacin.
    property URLNavigate: string read FURLNavigate write FURLNavigate;
    // URL del PDF de respuesta.
    property UrlPDF: string read FURLPDF;
    // : Constructor redefinido.
    constructor Create(AFileName: string; wb: TWebBrowser);
  end;

  // =========================================================================
  //
  // I M P L E M E N T A T I O N
  //
  // =========================================================================
implementation

uses
  StrUtils, SysUtils, Forms,
  UConstantes;

// procedimientos para obtener path de la aplicacin
function AppPath(): string;
begin
  Result := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
end;

// procedimientos para obtener path temporal
function AppTempPath(): string;
begin
  Result := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
  Result := IncludeTrailingBackslash(Result + STR_TEMP_DIR);
  ForceDirectories(Result);
end;


// : Corrige los link de relativos a absolutos de la pgina de IBPIndex.
function TWebThread._RepairLinks(StrPage: string; var URLpage: string;
  var UrlPDF: string): string;
var
  i: Integer;
  Str: String;
  TS: TStrings;
begin

  // Buscar ruta PDF
  i := AnsiPos('href="../analizado_pdf.asp?', StrPage);
  // encontrada?
  if (i > 0) then begin
    Str := Copy(StrPage, i + 9, Length(StrPage));

    // Grabar para debug
    // -------------------------------
    {
      TS := TStringList.CReate;
      TS.Text := Str;
      TS.SaveToFile(ApptempPath() + 'ibp.txt');
      FreeAndNil(TS);
    }
    // -------------------------------

    i := AnsiPos('">', Str);
    if (i > 0) then begin
      UrlPDF := Copy(Str, 1, i - 1);
      UrlPDF := IBPINDEX_INIPAGE + UrlPDF;
    end;
  end;

  // Modificar los links locales.
  Result := AnsiReplaceText(StrPage, 'href="../iestilos.css"',
    'href="http://www.ibpindex.com/iestilos.css"');
  Result := AnsiReplaceText(Result, 'src="pixel.gif"',
    'src="http://www.ibpindex.com/jom_e/pixel.gif"');
  Result := AnsiReplaceText(Result, 'src="ico_oo.gif"',
    'src="http://www.ibpindex.com/jom_e/ico_oo.gif"');
  Result := AnsiReplaceText(Result, 'src="ico_ko.gif"',
    'src="http://www.ibpindex.com/jom_e/ico_ko.gif"');
  Result := AnsiReplaceText(Result, 'src="icono-pdf.gif"',
    'src="http://www.ibpindex.com/jom_e/icono-pdf.gif"');
  Result := AnsiReplaceText(Result, 'href="../analizado_ifr.asp?',
    'href="http://www.ibpindex.com/analizado_ifr.asp?');
  Result := AnsiReplaceText(Result, 'href="../analizado_pdf.asp?',
    'src="http://www.ibpindex.com/analizado_pdf.asp?"');

  // Acceder a la "pagina" imprimible
  i := AnsiPos('<a href="http://www.ibpindex.com/analizado_ifr.asp?', Result);
  if (i > 0) then begin
    Str := Copy(Result, i + 9, Length(Result));

    i := AnsiPos('">', Str);
    if (i > 0) then begin
      URLpage := Copy(Str, 1, i - 1);
    end;
  end;

  // Buscar el link PDF
  Result := AnsiReplaceText(Result, 'href="../analizado_pdf.asp?',
    'src="http://www.ibpindex.com/analizado_pdf.asp?"');
end;

// constructor redefinido.
constructor TWebThread.Create(AFileName: string; wb: TWebBrowser);
begin

  inherited Create(True);

  Self.FTrackFileName := AFileName;
  Self.webBrowser := wb;
  // componente
  IdHTTP := TidHTTP.Create(nil);
  IdHTTP.HandleRedirects := True;

end;

procedure TWebThread.Execute();
var
  ruta: string;
  resp, url, DownPDF: string;
  TS: TStrings;
begin
  inherited;

  // fichero de ruta
  ruta := Trim(Self.FTrackFileName);
  // Ruta correcta?
  if (ruta <> STR_EMPTY) and FileExists(ruta) then begin
    // Preparar
    Stream := TIdMultipartFormDataStream.Create;
    Stream.AddFile('fichero', ruta, 'file');

    // Mientras tanto cargar el camculando....
    // -- wbIBPIndex.Navigate(IBPINDEX_CALCULANDO);
    // navegar a la pgina de "calculando"
    // --    Synchronize(Navigate);

    // Enviar los datos
    resp := IdHTTP.Post(IBPINDEX_WEBPAGE, Stream);
  end;

  // Obtener la respuesta
  Self.FResponse := _RepairLinks(resp, Self.FURLNavigate, DownPDF);
  Self.FURLPDF := DownPDF;
  Self.Response := resp;

  // Debug
  // ---------------------------------

    TS := TStringList.Create();
    TS.Text := resp;
    TS.SaveToFile(AppTempPath()+'ibp.html');
    TS.Free;

  // ---------------------------------

  Self.Terminate;

end;

end.
